// code by jph

package speller;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;

public class MouseController {
  
  int pix;
  int piy;
  
  public MouseController(final Speller mySpeller) {
    pix = mySpeller.mySpellerComponent.getSize().width / 2;
    piy = mySpeller.mySpellerComponent.getSize().height / 2;
    
    mySpeller.mySpellerComponent.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent myMouseEvent) {
        pix = myMouseEvent.getX();
        piy = myMouseEvent.getY();
      }
    });
    mySpeller.mySpellerComponent.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        mySpeller.myJFrame.dispose();
      }
      
      public void mouseExited(MouseEvent e) {
        pix = mySpeller.mySpellerComponent.getSize().width / 2;
        piy = mySpeller.mySpellerComponent.getSize().height / 2;
      }
    });
    
    new Thread() {
      public void run() {
        try {
          while (true) {
            mySpeller.mySpellerComponent.flush(6, 10, 40, pix / (double) mySpeller.mySpellerComponent.getSize().width, piy / (double) mySpeller.mySpellerComponent.getSize().height);
            sleep(1000 / 5);
          }
        } catch (Exception myException) {
          System.out.println(myException);
        }
      }
    }.start();
  }
  
  public static void main(String[] args) {
    new MouseController(new Speller(1, 200, 200, 1000, 800));
  }
}
