// code by jph

package speller;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.NavigableSet;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.JFrame;
import javax.swing.WindowConstants;

public class Speller {
  
  // TODO instead of dict.txt store low size binary of tree
  
  static private NavigableSet<String> loadBase() {
    NavigableSet<String> myNavigableSet = new TreeSet<String>();
    try {
      Pattern myPattern = Pattern.compile("[a-zA-Z]{2,}");
      BufferedReader myBufferedReader = new BufferedReader(new FileReader(new File("get" + File.separator + "txt" + File.separator + "de-en.txt")));
      String myLine;
      int split = 0;
      while ((myLine = myBufferedReader.readLine()) != null)
        if (!myLine.startsWith("#") && 0 < (split = myLine.indexOf(" :: "))) {
          Matcher myMatcher = myPattern.matcher(myLine.substring(split + 4).toLowerCase());
          while (myMatcher.find())
            myNavigableSet.add(myMatcher.group());
        }
      myBufferedReader.close();
    } catch (Exception myException) {
      System.out.println(myException);
    }
    try {
      Pattern myPattern = Pattern.compile("[a-zA-Z]+");
      BufferedReader myBufferedReader = new BufferedReader(new FileReader(new File("get" + File.separator + "txt" + File.separator + "extra.txt")));
      String myLine;
      while ((myLine = myBufferedReader.readLine()) != null)
        if (!myLine.startsWith("#")) {
          Matcher myMatcher = myPattern.matcher(myLine.toLowerCase());
          while (myMatcher.find()) 
            myNavigableSet.add(myMatcher.group());          
        }
      myBufferedReader.close();
    } catch (Exception myException) {
      System.out.println(myException);
    }
    
    List<String> myList = new LinkedList<String>();
    for (String myString : myNavigableSet) {
      if (myString.length() == 2) {
        SortedSet<String> mySortedSet = myNavigableSet.tailSet(myString, false);
        if (!mySortedSet.isEmpty())
          if (!mySortedSet.first().startsWith(myString))
            myList.add(myString);
      }
    }
    myNavigableSet.removeAll(myList);
    return myNavigableSet;
  }
  
  static List<String> follows(String myStart) {
    Set<String> mySet = new TreeSet<String>();
    for (String myString : myNavigableSet.tailSet(myStart).headSet(myStart + "{"))
      // ... y z { ... in ascii table
      mySet.add(myString.substring(myStart.length(), Math.min(myString.length(), myStart.length() + 1)));
    if (!myStart.isEmpty())
      mySet.add(BACKSPACE);
    return new ArrayList<String>(mySet);
  }
  
  static final NavigableSet<String> myNavigableSet = loadBase();
  
  static final String BACKSPACE = "\u21A4";
  public JFrame myJFrame = new JFrame();
  public SpellerComponent mySpellerComponent = new SpellerComponent();
  
  public Speller(int exit, int x, int y, int width, int height) {
    myJFrame.setContentPane(mySpellerComponent);
    myJFrame.setDefaultCloseOperation(exit == 0 ? WindowConstants.DISPOSE_ON_CLOSE : WindowConstants.EXIT_ON_CLOSE);
    myJFrame.setBounds(x, y, width, height);
    myJFrame.setVisible(true);
  }
  
}
