function nu_disp(varargin)
% code by jph

global nu user

if isempty(nu) | isempty(user)
  disp('remark: no valid data in memory')
  return
end

if ~isempty(findobj('Name',mfilename))
  close(findobj('Name',mfilename))
end

fig=figure('Name',mfilename,...
           'Numbertitle','off',... % 'Menubar','none',...       %  'Color',[0 0 0],...                     %'Colormap',[0 0 0;1 1 1],... % TODO see if makes difference !?                   
           'Toolbar','figure',...
           'Position',user.view);

if nargin
  swt=varargin{1}
else
  swt=nu.varargin{1}
end
           
switch swt

case 'prg_eyelock'

  sol=user.eye.corrcoef{end};
  subplot(1,2,1); nuscalp3(sol(:,2),sol(:,1),'text'); title('left/right'); view(-180,52); colorbar  
  subplot(1,2,2); nuscalp3(sol(:,3),sol(:,1),'text'); title('up/down');    view( 142, 0); colorbar

case 'prg_p300image'

  nw{1}=nuget('events.evaluated',{'p300image(1)','prg_p300image(1)'},'now',1);
  nw{2}=nuget('events.evaluated',{'p300image(2)','prg_p300image(2)'},'now',1);
  
  fprintf('%i vs. %i\n',length(nw{1}),length(nw{2}))
  [SYN,fin]=nuget('channel.extract',nu.light.channel);
  [GND,fin]=nuget('channel.extract',22);
  
  tit={'negatives','positives'};
  myr=cell(2,40);
  hnd={};
  axs=[];
  for c0=1:2
    bu{c0}=[];
    bs{c0}={};
    for c1=1:length(nw{c0})
      [res,sct]=nuget('triggered.flash',nw{c0}(c1));
      bu{c0}=vertcat(bu{c0},res);
      bs{c0}=vertcat(bs{c0},sct);
    end
    pn{c0}=ceil(interp1(fin,[1:length(fin)]',bu{c0}));
    ind=[-500:749]';
    hnd{c0}=subplot(3,2,c0*2-1);
    cnt=1;
    CHN=[19 33 20 34 21 22];
    for c2=1:40
      [ccz,fin]=nuget('channel.extract',c2);
      %cmp=ccz-GND;
      cmp=ccz; % wee lih says that gnd
      myr{c0,c2}=zeros(size(ind));
      for c1=1:length(pn{c0})
        if pn{c0}(c1)+ind(end)<length(cmp)
          myr{c0,c2}=myr{c0,c2}+cmp(pn{c0}(c1)+ind);
        end
      end
      fX=fft(myr{c0,c2});
      fq=40:650;
      fX([1+fq end-fq+1],:)=0;
      myr{c0,c2}=ifft(fX);
      myr{c0,c2}=nuget('remove.polynom',myr{c0,c2},1,'normalize');
      ext=30:length(ind)-30;            
      if ismember(c2,CHN)        
        plot(ind(ext)*1e-3,myr{c0,c2}(ext),'Color',nuget('color',cnt))
        hold on
        cnt=cnt+1;
      end
    end
    plot([0 0],[-0.06 0.06],'k:')
    xlabel('[sec]')
    title(['normalized potential averaged over ' num2str(length(pn{c0})) ' trials of ' tit{c0}])    
    axis tight
    axs=[axs;axis];
    legend(nu.text(CHN),'Location','EastOutside')
  end  
  for c0=1:2
    subplot(hnd{c0})
    axis([axs(1,1:2) min(axs(:,3)) max(axs(:,4))])
  end
  
  subplot(3,2,5)  
  plot(fin,SYN)
  hold on

  if length(bs{1}) | length(bs{2})
    mrk={'r','g'};
    res=[];
    for c0=1:2
      for c1=1:length(bs{c0})
        plot(bs{c0}{c1}.tic,bs{c0}{c1}.mean,[mrk{c0} '+'])
        plot(bs{c0}{c1}.toc,bs{c0}{c1}.mean,[mrk{c0} 'o'])
        res=[res bs{c0}{c1}.toc-bs{c0}{c1}.tic];
      end
    end
  else
    plot(bu{1},repmat((min(SYN)+max(SYN))*0.5,size(bu{1})),'r+')
  end

  ret=[mean(res) var(res)];
  title(['photodiode delay=' num2str(ret(1)) '  var=' num2str(ret(2))])
  axis tight
  fprintf(' mean=%e\n var =%e\n',ret) %TODO what does this MEAN
  
  X=cell2mat(nuget('filter',1:nu.numel,[10 30 50 70 90]));
  chn=find(all(X<1));
  if strcmp(user.title,'simulink')
    chn=user.simulink.channel;
  end
  
  nuc=setdiff(chn,[22 37]);
  for c0=1:2
    val=[];
    for c2=nuc
      val=[val var(myr{c0,c2}(600:end))/var(myr{c0,c2}(1:500))];
    end
    subplot(2,2,c0*2)
    nuscalp3(log(val),nuc)
    title(tit{c0}); view(-95,56); colorbar
  end

case 'prg_emptywin'

  sub=nuget('varargin.struct','title','unknown');
  switch sub
  case 'randomcurve_video'  
    subplot(2,1,2)
    col=nuget('video.triggers','plot');
    if ~isempty(col)
      load(['res/rd_' nuget('varargin.struct','avifile')],'bi')      
      sec=120;
      tim=linspace(0,sec,sec*2+1);
      tim(end)=[];
      
      X=cell2mat(nuget('filter',1:nu.numel,[10 30 50 70 90]));
      X=nuget('channel.41.append',X);
      chn=setdiff(find(all(X<1)),37);
      X=nuget('ground',X,[1:41]==22);
      
      len=500;
      dom=linspace(0,0.5,len+1)';
      dom(end)=[];
      lhs=cell(length(col),1);
      rhs=cell(length(col),1);
      shs=cell(length(col),1);
      for c1=1:length(col)  
        lhs{c1}=X(col(c1)+[1:len],chn);
        rhs{c1}=interp1(bi.dom,bi.pnt(1,:),tim(c1)+dom,'cubic');
        shs{c1}=interp1(bi.dom,bi.pnt(2,:),tim(c1)+dom,'cubic');
      end
      lhs=cell2mat(lhs);
      rhs=cell2mat(rhs);
      shs=cell2mat(shs);
      
      dat={};
      for c1=1:size(lhs,2)
        dat=horzcat(dat,nuget('remove.polynom',lhs(:,c1),3,'normalize'));
      end
      lhs=cell2mat(dat);
      
      ve1=nuget('remove.polynom',rhs,0,'normalize')'*lhs;
      ve2=nuget('remove.polynom',shs,0,'normalize')'*lhs;
      
      subplot(2,2,1); nuscalp3(ve1,chn); title('left/right'); view(-180,52); colorbar  
      subplot(2,2,2); nuscalp3(ve2,chn); title('up/down');    view( 142, 0); colorbar
    else
      title('no trigger found')      
    end
  otherwise
    fprintf('remark: display for <a href="">%s</a> not yet supported\n',sub)
  end

case 'prg_randomcurve'

  X=cell2mat(nuget('filter',1:nu.numel,[10 30 50 70 90]));
  [X,smp]=nuget('decimate',X,4);
  X=nuget('channel.41.append',X);
  chn=setdiff(find(all(X<1)),37);
  if strcmp(user.title,'simulink')
    chn=user.simulink.channel;
  end
  X=nuget('ground',X,[1:41]==22);
  RET=nuget('events.evaluated','prg_randomcurve(''loop'')','return',4);
  fnd=find(diff(RET(:,1))<eps);
  RET(fnd,:)=[];
  tim=RET(:,1);
  smp=smp-0.22;
  lo=find(tim(  1)<=smp);
  hi=find(smp     <=tim(end));
  ind=lo(1):hi(end);
  smp=smp(ind);
  X=X(ind,:);
  
  m_x =nuget('remove.polynom',interp1(tim,RET(:,2),smp,'linear'),0,'normalize');
  m_y =nuget('remove.polynom',interp1(tim,RET(:,3),smp,'linear'),0,'normalize');
  
  dat={};
  for c1=chn
    dat=horzcat(dat,nuget('remove.polynom',X(:,c1),3,'normalize'));
  end
  dat=cell2mat(dat)';

  %plot(dat(1,:)); hold on; plot(m_y); hold off

  subplot(1,2,1); nuscalp3(dat*m_x,chn,'plot','text'); title({'Interpolated linear correlation coefficient of','EEG channels and horizontal eyes orientation'}); view(-180,52); colorbar 
  subplot(1,2,2); nuscalp3(dat*m_y,chn,'plot','text'); title({'Interpolated linear correlation coefficient of','EEG channels and vertical eyes orientation'})   ; view(-180,52); colorbar

otherwise
  fprintf('remark: display for <a href="">%s</a> not yet supported\n',nu.varargin{1})
end

disp('remark: figure not exported')

cnt=0;
for c1=findobj('type','figure')';
  set(c1,'Color',[1 1 1])
  try
    fn=sprintf('out/%s_%i.png',nuget('filename'),cnt);
    export_fig(fn) % previously print('-dpng',fn)
    %fprintf('remark: figure exported <a href="">%s</a>\n',fn) 
  catch end
  cnt=cnt+1;   
end

