function nu_setup(varargin)
% code by jph
%
% run nu_setup during the initial phase
% while connecting the quick gel to the electrodes

javaaddpath(pwd)
global nu user

nuinit('user',varargin)

fprintf('remark: user <a href="">%s</a>\n',user.title);

figure('Name',['Setup for user: ' user.title],...
       'Numbertitle','off',...
       'Menubar','none',...
       'Position',user.view,...
       'WindowButtonMotionFcn','nuevent(0,0,7)',...
       'WindowButtonDownFcn','nuevent(0,0,8)',...
       'KeyPressFcn','nuevent(0,0,9)',... 
       'Color',[1 1 1],...
       'CloseRequestFcn','nuget(''closereq'');'); % this happens in global scope!

nuinit('nu')
nuhardware

nu.varargin={'setup'};

while nu.numel<5
  pause(0.05)
end

act=[];
drw=[];

while nu.run
  X=cell2mat(nu.cell(nu.numel+[-4:0]));
  chn=find(X(1,:)<1);
  if length(chn)
    mX=mean(X(:,chn),2);    
    X(:,chn)=X(:,chn)-repmat(mX,[1 length(chn)]);  
  else
    mX=zeros(length(X),1);
  end
  fX=fft(X);
  
  subplot(2,2,1)
  nuscalpf(abs(fX(3,chn)),chn,'plot','text','contour')
  title('electrodes status')
  
  s=mean(abs(fX),2); s(1)=0;
  subplot(2,2,3)
  semilogy(-500:499,fftshift(s))
  grid on
  grid minor
  xlabel('Frequency [Hz]')
  tim1=nu.toc;
  tim2=nu.numel*0.2;
  title(sprintf('clock [toc=%6.2f EEG=%6.2f DELTA=%6.4f]',tim1,tim2,tim2-tim1))
  
  for c2=chn
    if ~ismember(c2,act)
      act=[act c2];
    end
  end
  
  drw=act(max(1,end-4):end);
  subplot(max(1,length(drw)),2,2)
  plot(mX)
  for c2=2:length(drw)
    subplot(length(drw),2,2*c2)
    if 0
      plot(X(:,drw(c2)))
    else
      fX(50:end-48,:)=0;
      X=ifft(fX); %sum(sum(abs(imag(X))))
      plot(X(:,drw(c2)))
    end
    ylabel([nu.text{drw(c2)} ' (' num2str(drw(c2)) ')'])
  end
  
  drawnow
  pause(0.3)
end

nu_break('nowarning')

if ~strcmp(user.title,'simulink')
  nu_save
end
