function nuevent(void1,void2,cmd,varargin)
% code by neuroscan, neisha amy chadwick, jph
% execution time is required to be far less than 0.2 sec

global nu user

%disp(cmd)

switch cmd
  case 2  % NOTIFY_DATA
    %disp('NOTIFY_DATA')
    try
      myICmpDeviceExtensions=nu.server.invoke('ICmpDeviceExtensions');  % data is ready to be retrieved from the device
      data=myICmpDeviceExtensions.invoke('ReadDataEx');                 % data is an array of floats
      raw=reshape(double(data(2:end)),[200 40]);
      %raw=reshape(double(data(2:end)),[50 41]);      
      %disp(raw(:,end)')
      if ~nu.numel
        tic
        nu.clock=clock;
      end
      nu.toc=toc;
      nu.now=vertcat(nu.now,nu.toc);
      if 2<nu.numel & strcmp(user.title,'simulink')
        ref=nu.toc-user.simulink.pause;
        ind=1;
        for c1=numel(nu.trace.mouse):-1:1
          if nu.trace.mouse{c1}(1)<ref-0.2
            ind=c1;
            break
          end
        end
        if ref<nu.trace.mouse{end}(1)
          mse=cell2mat(nu.trace.mouse(ind:end));
        else
          mse=cell2mat(vertcat(nu.trace.mouse(ind:end),[ref nu.trace.mouse{end}(2:end)]));
        end
        tim=linspace(ref-0.199,ref,200)';
        msx=interp1(mse(:,1),(mse(:,2)-840)/840,tim,'linear');
        msy=interp1(mse(:,1),(mse(:,3)-525)/525,tim,'linear');
        chn=[1:36 39 40];
        raw(:,chn)=randn(200,numel(chn)).*user.simulink.var + ... 
                   user.simulink.power + ...
                   msx*user.simulink.eye.x + ...
                   msy*user.simulink.eye.y; % 
        %fprintf('simulation time %f\n',toc-nu.toc)
      end
      %raw=raw-0.5*repmat(raw(:,11)+raw(:,12),[1 40]);
      nu.cell=vertcat(nu.cell,raw);
      nu.numel=length(nu.cell); % do not advance line (for thread safety)
    catch exception
      if nu.numel
        disp(exception)
      end
    end    
  case 3  % NOTIFY_CONNECT_NO_CONFIG
    %disp('NOTIFY_CONNECT_NO_CONFIG')
    fid=fopen('res/nuamps.xml','r');
    config='';
    while ~feof(fid)
      config=[config fgetl(fid)];
    end
    fclose(fid);
    disp('remark: device configuration via <a href="nuamps.xml">nuamps.xml</a>.')    
    try
      nu.device.Configuration=config;  % TODO get(device,'Configuration',strConfiguration);
      gBlocksPerSecond=nu.device.BlocksPerSecond;
      disp(['gBlocksPerSecond ' num2str(gBlocksPerSecond)])
      gSampleRate=zeros(40,1);
      for m = 1:40
        myChannel=get(nu.device,'Channel',m-1); % TODO: device.Channel(m) ?
        gSampleRate(m)=myChannel.SampleRate;
      end
      %gSampleRate
      if 1<length(unique(gSampleRate))
        gSampleRate'
        disp('sampling rate has to be unique for all channels!')
      end
      try
        nu.device.invoke('EnableData',true);   % and finally, enable the data stream      
      catch
        disp(' error: no evoke possible')
      end
    catch
      disp(' error: configuration not accepted !!!')
    end
    
    %disp('asd')
  % case 4 == NOTIFY_IMPEDANCE_READY
  % case 5 == NOTIFY_LOST_PKTS
  case 7 % mouse motion
    % TODO mouse location buffer overflow
    if nu.numel % required because of toc command
      nu.trace.mouse=vertcat(nu.trace.mouse,[toc get(0,'PointerLocation')]);
    end
  case 8 % mouse button
    if nu.numel % required because of toc command
      nu.trace.print=vertcat(nu.trace.print,[toc get(0,'PointerLocation')]);
    end
  case 9
    if nu.numel % required because of toc command
      nu.trace.keyboard=vertcat(nu.trace.keyboard,toc);
    end
  otherwise % error, don't know what to do with other types
    error(['unexpected event id: ' num2str(cmd)])
end
