function nuinit(cmd,varargin)
% code by jph
%
% initialize struct nu user

global nu user

rehash
switch cmd

case 'nu'

  nu=0; % this ensures data integrity
  warning('OFF','MATLAB:warn_r14_stucture_assignment')
  nu.cell=cell(0); % raw data in [V] (!never modified after readout!)
  warning('ON','MATLAB:warn_r14_stucture_assignment')
  
  nu.numel=0;
  nu.toc=0;
  nu.now=cell(0);
  nu.case=0;
  nu.run=1;
  nu.events=cell(0); % new event system introduced on 2010 04 13
  nu.datestr=datestr(now,30); % begin of 
  nu.light.channel=37;  
  nu.light.shading=0; % additional samples needed after pulse: 1 unit = 1e-3 sec  
  nu.light.legend={};
  nu.light.events=cell(0); % indices to nuevent, which has timing
  nu.light.cell=cell(0); % see if notation is OK  TODO probably not needed
  nu.sound.channel=38;
  nu.trace.mouse={[-10 get(0,'PointerLocation')];[0 get(0,'PointerLocation')]};
  nu.trace.print=cell(0);
  nu.trace.keyboard=cell(0);
  
  % channel ordering of 
  nu.text={
    'Fp1'     %  1
    'Fp2'     %  2
    'F3'      %  3
    'F4'      %  4
    'C3'      %  5
    'C4'      %  6
    'P3'      %  7
    'P4'      %  8
    'O1'      %  9
    'O2'      % 10
    'A1'      % 11
    'A2'      % 12
    'F7'      % 13
    'F8'      % 14
    'T3'      % 15
    'T4'      % 16
    'T5'      % 17
    'T6'      % 18
    'Fz'      % 19
    'Cz'      % 20
    'Pz'      % 21
    'Oz'      % 22
    'PO1'     % 23  X7
    'PO2'     % 24  X8
    'FC3'     % 25
    'FC4'     % 26
    'CP3'     % 27
    'CP4'     % 28
    'FT7'     % 29
    'FT8'     % 30
    'TP7'     % 31
    'TP8'     % 32
    'FCz'     % 33
    'CPz'     % 34
    'X2'      % 35
    'X3'      % 36
    'X1'      % 37       (photo diode)
    'X4'      % 38       (microphone)
    'FT9'     % 39  X5
    'FT10'    % 40  X6
    'Gnd'     % 41
    'Trg'     % 42
  };
  
  % nuscalp
  nu.grid=[
   -1   3     %  1       Fp1
    1   3     %  2       Fp2
   -1   2     %  3       F3
    1   2     %  4       F4
   -1   0     %  5       C3
    1   0     %  6       C4
   -1  -2     %  7       P3
    1  -2     %  8       P4
   -1  -3     %  9       O1
    1  -3     % 10       O2
   -3  -2     % 11       A1
    3  -2     % 12       A2
   -2   2     % 13       F7
    2   2     % 14       F8
   -2   0     % 15       T3
    2   0     % 16       T4
   -2  -2     % 17       T5
    2  -2     % 18       T6
    0   2     % 19       Fz
    0   0     % 20       Cz
    0  -2     % 21       Pz
    0  -3     % 22       Oz
   -2  -3     % 23       X7
    2  -3     % 24       X8
   -1   1     % 25       FC3
    1   1     % 26       FC4
   -1  -1     % 27       CP3
    1  -1     % 28       CP4
   -2   1     % 29       FT7
    2   1     % 30       FT8
   -2  -1     % 31       TP7
    2  -1     % 32       TP8
    0   1     % 33       FCz
    0  -1     % 34       CPz
   -2   3     % 35       X2
    2   3     % 36       X3
   -3   3     % 37       X1
    3   3     % 38       X4
   -3   2     % 39       X5
    3   2     % 40       X6
    0   3     % 41       GND
    0   3     % 42       TRG
  ];
  
  % nuscalpf
  nu.plot=[
    -0.306316   0.877936    %  1       Fp1
     0.306316   0.877936    %  2       Fp2
    -0.320151   0.489474    %  3       F3
     0.320151   0.489474    %  4       F4
    -0.399347   0.119808    %  5       C3
     0.399347   0.119808    %  6       C4
    -0.332747  -0.255581    %  7       P3
     0.332747  -0.255581    %  8       P4
    -0.285633  -0.685312    %  9       O1
     0.285633  -0.685312    % 10       O2
    -1         -0.030061    % 11       A1
     1         -0.030061    % 12       A2
    -0.580442   0.632585    % 13       F7
     0.580442   0.632585    % 14       F8
    -0.794918   0.156899    % 15       T3
     0.794918   0.156899    % 16       T4
    -0.639394  -0.422059    % 17       T5
     0.639394  -0.422059    % 18       T6
     0          0.500590    % 19       Fz
     0          0           % 20       Cz
     0         -0.329392    % 21       Pz
     0.000000  -0.784506    % 22       Oz
    -0.159554  -0.534138    % 23       PO1/X7
     0.159554  -0.534138    % 24       PO2/X8
    -0.376274   0.296024    % 25       FC3
     0.376274   0.296024    % 26       FC4
    -0.396834  -0.075298    % 27       CP3
     0.396834  -0.075298    % 28       CP4
    -0.721899   0.425347    % 29       FT7
     0.721899   0.425347    % 30       FT8
    -0.750466  -0.150785    % 31       TP7
     0.750466  -0.150785    % 32       TP8
     0          0.249306    % 33       FCz
     0         -0.192270    % 34       CPz
    -0.600000   0.877936    % 35       X2
     0.600000   0.877936    % 36       X3
    -0.900000   0.877936    % 37       X1
     0.900000   0.877936    % 38       X4
    -0.916100   0.403594    % 39       FT9/X5
     0.916100   0.403594    % 40       FT10/X6
     0          0.704388    % 41       GND
     0          0.704388    % 42       TRG
  ];
  
  [nu.x1,nu.x2]=meshgrid(-3:3,-3:3);
  
  nu.inmem=(nu.grid+3)*[7;1]+1;

case 'user'

  user=0; % this ensures data integrity
  warning('OFF','MATLAB:warn_r14_stucture_assignment')
  user.title='unknown';
  warning('ON','MATLAB:warn_r14_stucture_assignment')
  
  if numel(varargin)
    varargin=varargin{1};
  end
  
  if numel(varargin)
    user.title=varargin{1};
  end
  if ~ischar(user.title)
    error('provide user name as string');
  end
  
  user.view=[1 1 1680 1024];%[0 0 1680 1024];
  user.eye.corrcoef=cell(0);
  user.eye.classdef=cell(0);
  
  user.simulink.channel=[1:36 39 40];  
  user.simulink.eye.x=[
    -3.601e-006 +1.073e-005 -1.015e-005 +7.826e-006 -8.887e-006 +4.644e-006 -6.334e-006 +1.045e-006 -4.369e-006 -1.220e-006 -1.518e-005 +5.430e-006 -2.813e-005 +2.294e-005 -1.674e-005 +9.103e-006 -5.459e-006 +1.953e-006 -1.652e-007 -1.776e-006 -2.944e-006 -3.155e-006 -3.594e-006 +2.470e-006 -9.887e-006 +6.636e-006 -7.543e-006 +2.061e-006 -2.641e-005 +1.687e-005 -6.874e-006 +5.774e-006 -1.418e-006 -2.356e-006 -1.730e-005 +8.529e-006 -2.545e-005 +1.550e-005
  ];
  user.simulink.eye.y=[
    -2.421e-006 +4.222e-007 -2.925e-006 -5.393e-006 -8.359e-006 -7.449e-006 -8.868e-006 -8.777e-006 -9.433e-006 -1.014e-005 -1.693e-005 -1.574e-005 -2.564e-006 -8.787e-006 -8.859e-006 -1.021e-005 -8.125e-006 -1.009e-005 -3.552e-006 -5.942e-006 -8.878e-006 -1.030e-005 -9.203e-006 -8.085e-006 -5.009e-006 -6.403e-006 -8.100e-006 -8.283e-006 -8.210e-006 -1.074e-005 -1.952e-005 -1.118e-005 -4.753e-006 -8.614e-006 -3.670e-005 -3.603e-005 -1.081e-005 -1.689e-005
  ];
  
  tmp=zeros(200,38);  
  ins=[
      -3.781e-004 -8.229e-004 -4.510e-004 -4.430e-004 -4.437e-004 -7.332e-004 -4.975e-004 -4.054e-004 -7.601e-004 -4.146e-004 -4.616e-003 -1.296e-003 -3.991e-004 -4.404e-004 -3.359e-004 -5.155e-004 -5.283e-004 -4.443e-004 -5.943e-004 -4.328e-004 -4.332e-004 -4.145e-004 -4.408e-004 -8.220e-004 -5.267e-004 -5.689e-004 -4.737e-004 -3.960e-004 -3.331e-004 -4.935e-004 -3.760e-004 -3.930e-004 -4.305e-004 -5.215e-004 -1.525e-003 -8.149e-004 -3.902e-004 -7.604e-004 
      -2.031e-005 -2.670e-006 -2.702e-005 -2.981e-005 -2.303e-005 -1.271e-005 -2.884e-005 -2.826e-005 -3.155e-005 -3.841e-005 +4.832e-004 +4.270e-005 -2.897e-005 -2.378e-005 -2.702e-005 -1.697e-005 -5.761e-005 -3.687e-005 -1.764e-005 -4.464e-005 -2.850e-005 -5.427e-005 -4.481e-005 -5.675e-006 -3.100e-005 -2.925e-005 -3.894e-005 -4.058e-005 -1.855e-005 -1.415e-005 -2.936e-005 -1.853e-005 -2.658e-005 -3.434e-005 +1.917e-004 +1.271e-005 -2.913e-005 -1.918e-005 
      -1.172e-005 +1.770e-005 -1.275e-005 -1.792e-005 -1.626e-005 +1.001e-005 -1.664e-005 -1.520e-005 -3.426e-006 -1.848e-005 +3.743e-004 +6.004e-005 -2.311e-005 -1.851e-005 -2.754e-005 -7.729e-006 -2.533e-005 -1.180e-005 -1.154e-006 -2.192e-005 -1.789e-005 -3.192e-005 -1.142e-005 +3.451e-005 -1.851e-005 -1.289e-005 -2.505e-005 -2.298e-005 -1.400e-005 -2.573e-007 -1.670e-005 -6.782e-006 -2.399e-005 -1.475e-005 +3.851e-005 +1.945e-005 +9.887e-006 +1.387e-005 
      -2.072e-005 -7.594e-006 -2.327e-005 -2.689e-005 -2.720e-005 -2.525e-005 -2.790e-005 -2.718e-005 -2.033e-005 -2.632e-005 +1.776e-004 +1.558e-006 -2.751e-005 -2.562e-005 -3.124e-005 -1.511e-005 -2.155e-005 -2.623e-005 -1.715e-005 -2.376e-005 -2.359e-005 -2.679e-005 -2.371e-005 -1.112e-005 -2.596e-005 -2.386e-005 -2.575e-005 -2.505e-005 -2.484e-005 -2.663e-005 -2.765e-005 -2.744e-005 -2.537e-005 -2.109e-005 +8.533e-006 -1.861e-005 -1.317e-005 -2.393e-005 
    ]+[
      +2.978e-005 +1.131e-003 +7.679e-005 -1.780e-005 +1.075e-005 +6.268e-004 +4.500e-005 -7.041e-005 +7.499e-004 -4.965e-005 +1.459e-002 +2.156e-003 -8.914e-005 -2.038e-005 +8.604e-005 +2.947e-004 +2.354e-004 -1.312e-005 +4.869e-004 -5.870e-005 +6.236e-005 -2.885e-005 -2.265e-005 +2.145e-003 +9.193e-005 +2.559e-004 -9.000e-006 -5.967e-005 +9.286e-006 +1.382e-004 +1.317e-004 -6.595e-005 -2.216e-005 +1.497e-004 +2.971e-003 +1.015e-003 +5.649e-004 +8.563e-004 
      +4.287e-005 +6.722e-005 +4.486e-005 +4.782e-005 +4.934e-005 +7.380e-005 +4.887e-005 +4.415e-005 +6.236e-005 +3.209e-005 +5.319e-004 +1.119e-004 +2.766e-005 +4.718e-005 +4.029e-005 +5.046e-005 +4.034e-005 +4.037e-005 +5.395e-005 +3.159e-005 +4.438e-005 +3.197e-005 +3.772e-005 +6.438e-005 +4.339e-005 +4.721e-005 +3.615e-005 +3.472e-005 +2.485e-005 +4.324e-005 +5.098e-005 +4.644e-005 +4.252e-005 +4.832e-005 +2.173e-004 +6.419e-005 +2.235e-005 +7.068e-005 
      +3.948e-005 +4.304e-005 +4.337e-005 +3.977e-005 +3.489e-005 +5.151e-005 +3.562e-005 +3.340e-005 +3.688e-005 +2.828e-005 +1.755e-004 +6.433e-005 +3.505e-005 +3.898e-005 +2.147e-005 +4.091e-005 +3.227e-005 +3.730e-005 +3.754e-005 +3.853e-005 +3.810e-005 +3.097e-005 +3.700e-005 +4.789e-005 +3.822e-005 +4.495e-005 +3.862e-005 +3.490e-005 +3.215e-005 +3.750e-005 +3.015e-005 +4.502e-005 +3.351e-005 +4.194e-005 +9.486e-005 +4.491e-005 +2.844e-005 +6.231e-005 
      +3.570e-005 +5.592e-005 +4.031e-005 +3.729e-005 +4.053e-005 +6.329e-005 +4.544e-005 +4.085e-005 +6.554e-005 +4.064e-005 +3.132e-004 +8.190e-005 +3.227e-005 +3.784e-005 +2.839e-005 +3.873e-005 +4.276e-005 +3.802e-005 +4.516e-005 +3.506e-005 +3.783e-005 +3.640e-005 +3.978e-005 +7.354e-005 +4.007e-005 +4.671e-005 +3.522e-005 +3.188e-005 +3.012e-005 +4.458e-005 +4.123e-005 +3.870e-005 +3.681e-005 +4.275e-005 +8.883e-005 +5.294e-005 +2.927e-005 +6.531e-005 
    ]*i;
  frq=[10 30 50 70];
  tmp(    frq+1,:)=ins;
  tmp(end-frq+1,:)=conj(ins);
  user.simulink.power=ifft(tmp) + ...  
    repmat([-1.565e-002 -1.562e-002 -1.005e-003 -9.745e-004 -5.779e-003 +7.851e-004 -6.498e-004 -3.904e-004 -4.325e-003 +3.959e-004 -5.442e-002 -6.131e-002 -2.870e-003 +1.333e-003 -2.945e-003 -3.778e-003 -2.195e-002 -2.260e-003 +1.806e-003 +1.382e-003 +3.297e-004 -4.234e-004 -3.949e-004 -2.448e-002 -1.167e-003 +1.274e-003 -3.102e-004 -7.786e-004 -2.086e-002 -2.639e-003 -2.329e-002 -6.964e-004 +1.487e-003 -1.545e-003 -8.830e-002 -7.989e-002 -1.866e-002 -8.346e-003],[200 1]);
  % TODO can be combined with ifft
  
  %sum(sum(abs(imag(user.simulink.power))))
  user.simulink.var=repmat([
      +3.854e-006 +4.920e-006 +3.835e-006 +3.797e-006 +4.095e-006 +4.139e-006 +5.485e-006 +5.267e-006 +9.561e-006 +8.780e-006 +1.237e-005 +6.276e-006 +5.171e-006 +5.281e-006 +6.560e-006 +7.514e-006 +7.642e-006 +6.415e-006 +3.156e-006 +3.989e-006 +5.516e-006 +9.124e-006 +6.972e-006 +7.059e-006 +3.842e-006 +3.704e-006 +4.643e-006 +4.714e-006 +5.016e-006 +4.852e-006 +6.632e-006 +6.050e-006 +3.310e-006 +4.412e-006 +7.288e-006 +5.872e-006 +5.411e-006 +5.614e-006 
    ],[200 1]);
  user.simulink.pause=0.185;
end



  %user.simulink.eye.corrcoef=[ % taken from user wl
  %   -0.0925     -0.0540     %     1    'Fp1'  
  %    0.6864      0.0234     %     2    'Fp2'  
  %   -0.8132     -0.2034     %     3    'F3'   
  %    0.6981     -0.4175     %     4    'F4'   
  %   -0.5564     -0.4543     %     5    'C3'   
  %    0.4338     -0.6040     %     6    'C4'   
  %   -0.4674     -0.5681     %     7    'P3'   
  %    0.0918     -0.6696     %     8    'P4'   
  %   -0.2931     -0.5492     %     9    'O1'   
  %   -0.1006     -0.7255     %    10    'O2'   
  %   -0.5947     -0.5757     %    11    'A1'   
  %    0.2624     -0.6601     %    12    'A2'   
  %   -0.8812     -0.0697     %    13    'F7'   
  %    0.8407     -0.2794     %    14    'F8'   
  %   -0.7758     -0.3563     %    15    'T3'   
  %    0.5685     -0.5533     %    16    'T4'   
  %   -0.2840     -0.3669     %    17    'T5'   
  %    0.1600     -0.7175     %    18    'T6'   
  %   -0.0267     -0.4988     %    19    'Fz'   
  %   -0.1895     -0.5503     %    20    'Cz'   
  %   -0.2373     -0.6211     %    21    'Pz'   
  %   -0.2474     -0.7014     %    22    'Oz'   
  %   -0.2935     -0.6523     %    23    'PO1'  
  %    0.0832     -0.2364     %    24    'PO2'  
  %   -0.7705     -0.3388     %    25    'FC3'  
  %    0.6266     -0.5247     %    26    'FC4'  
  %   -0.5520     -0.5145     %    27    'CP3'  
  %    0.1946     -0.6789     %    28    'CP4'  
  %   -0.7100     -0.1916     %    29    'FT7'  
  %    0.7506     -0.4147     %    30    'FT8'  
  %   -0.0936     -0.2307     %    31    'TP7'  
  %    0.4084     -0.6866     %    32    'TP8'  
  %   -0.1955     -0.5689     %    33    'FCz'  
  %   -0.1985     -0.6298     %    34    'CPz'  
  %   -0.3919     -0.7214     %    35    'X2'   
  %    0.2087     -0.7651     %    36    'X3'   
  %   -0.7280     -0.2684     %    39    'FT9'  
  %    0.6232     -0.5896     %    40    'FT10' 
  %];
  
