% code by jph

function nuscalpf(val,chn,varargin)

global nu
persistent model

if isempty(model)
  disp('remark: load head model')
end

res=50;
if ismember('res100',varargin)
  res=100;
end

if ~isfield(model,'union')
  model.union=[-1];
end

key=[res chn];

eql=length(model.union)==length(key) & isfield(model,'align');
if eql
  eql=all(model.union==key);
end

if ~eql
  [model.X,model.Y]=meshgrid(linspace(-1,1,res));
  model.Z=repmat(NaN,[res res]);
  model.A=zeros(res);
  hgt=0.17;
  rad=1.3;
  pow=4;
  model.fnd=find(sqrt(model.X.*model.X+(model.Y-hgt).*(model.Y-hgt))<rad);
  model.align=zeros(length(chn),length(model.fnd));
  c1=1;
  for c0=model.fnd'
    dst=repmat([model.X(c0) model.Y(c0)],[length(chn) 1])-nu.plot(chn,:);
    wgt=1./(sqrt(sum(dst.*dst,2)).^pow+eps);
    model.align(:,c1)=wgt/sum(wgt);
    c1=c1+1;
  end
  model.A(model.fnd)=1;
  model.union=key;
end 

model.Z(model.fnd)=reshape(val,[1 numel(val)])*model.align;

if ismember('imagesc',varargin)
  hnd=imagesc([-1 1],[-1 1],model.Z);
  set(hnd,'AlphaData',model.A)
  set(get(hnd,'Parent'),'YDir','normal')
else
  plot(0,0)
end

axis equal
axis tight
axis off
hold on

if ismember('plot',varargin)
  cmp=setdiff(1:41,chn);
  hnd=plot(nu.plot(cmp,1),nu.plot(cmp,2),'.r');
  set(hnd,'MarkerSize',20)
end

if ismember('text',varargin)
  for c1=chn
    hnd=text(nu.plot(c1,1),nu.plot(c1,2),nu.text{c1});
    set(hnd,'FontSize',7)
    set(hnd,'HorizontalAlignment','center')
  end  
end

if ismember('contour',varargin) & 1<length(unique(val))
  [cnt,hnd]=contour(model.X,model.Y,model.Z);
  set(hnd,'LineColor',[0.2 0.2 0.2])
  if ismember('clabel',varargin)
    clabel(cnt,hnd);
  end
end

%if ismember('contour',varargin)
%lab=[11 12 15 16 20 22 41];
%for c1=lab(find(ismember(lab,chn)))
%  hnd=text(nu.plot(c1,1),nu.plot(c1,2),nu.text{c1});
%  set(hnd,'FontSize',7)
%  set(hnd,'HorizontalAlignment','center')
%  set(hnd,'VerticalAlignment','top')
%  %get(hnd)
%end

hold off
