function varargout=nuscalpi(val,chn,varargin)
% code by jph
% example 1 ---
%  nuscalp3(rand(1,41),1:41)
%
% example 2 ---
%  hnd=[];
%  for c1=1:20
%    hnd=nuscalp3(rand(1,41),1:41,hnd)
%    pause(1)
%  end

global nu
persistent model

if isempty(model)
  disp('remark: load flat model')
  load 'res/flat_model'
end

chn=reshape(chn,[1 numel(chn)]);
eql=find(ismember(model.union,num2str(chn)));

res=70; % TODO this is not the final design

if isempty(eql)
  disp('remark: computing interpolation')
  [X,Y]=meshgrid(linspace(-1,1,res));
  model.alpha=zeros(res);
  hgt=0.17;
  rad=1.3;
  pow=4;
  fnd=find(sqrt(X.*X+(Y-hgt).*(Y-hgt))<rad);
  agn=zeros(numel(chn),numel(fnd));
  c1=1;
  for c0=fnd'
    dst=repmat([X(c0) Y(c0)],[numel(chn) 1])-model.plot(chn,:);
    wgt=1./(sqrt(sum(dst.*dst,2)).^pow+eps);
    agn(:,c1)=wgt/sum(wgt);
    c1=c1+1;
  end
  model.alpha(fnd)=1;
  model.union=horzcat(model.union,num2str(chn));
  model.find =horzcat(model.find,fnd);
  model.align=horzcat(model.align,agn);
  eql=length(model.union);
end 

hnd=[];
if length(varargin)
  if isnumeric(varargin{1})
    hnd=varargin{1};
    varargin=varargin(2:end);
  end
end

col=repmat(NaN,[res res]);
col(model.find{eql})=reshape(val,[1 numel(val)])*model.align{eql};

if ismember('normalize',varargin)
  bnd       =[-1 1];
  col(1,1:2)=[-1 1];
else
  bnd=[min(val) max(val)];
end

if isempty(hnd)
%if ismember('imagesc',varargin)
  hnd=imagesc([-1 1],[-1 1],col);
  axis equal
  axis tight
  axis off
  set(hnd,'AlphaData',model.alpha)
  set(get(hnd,'Parent'),'YDir','normal')
else
  set(hnd,'CData',col)
end

%if ismember('plot',varargin)
%  cmp=setdiff(1:41,chn);
%  hnd=plot(nu.plot(cmp,1),nu.plot(cmp,2),'.r');
%  set(hnd,'MarkerSize',20)
%end

%if ismember('text',varargin)
%  for c1=chn
%    hnd=text(nu.plot(c1,1),nu.plot(c1,2),nu.text{c1});
%    set(hnd,'FontSize',7)
%    set(hnd,'HorizontalAlignment','center')
%  end  
%end

%if ismember('contour',varargin)
%lab=[11 12 15 16 20 22 41];
%for c1=lab(find(ismember(lab,chn)))
%  hnd=text(nu.plot(c1,1),nu.plot(c1,2),nu.text{c1});
%  set(hnd,'FontSize',7)
%  set(hnd,'HorizontalAlignment','center')
%  set(hnd,'VerticalAlignment','top')
%  %get(hnd)
%end

if nargout
  varargout{1}=hnd;
end
