function val=prg_cleaner(varargin)
%code by jph

global nu user
persistent prg

val=[];

if isempty(findobj('type','figure','name',mfilename))
  if ~nargin
    sec=nuget('varargin.struct','sec',600);
    nurun(1:0.05:sec ,'prg_cleaner(''loop'')')
    nurun(sec        ,'prg_cleaner(''stop'')')
    prg.figure=figure('Name',mfilename,...
                      'Numbertitle','off',...
                      'Menubar','none',...
                      'Color',[1 1 1],...
                      'WindowButtonMotionFcn','nuevent(0,0,7)',... % for simulink
                      'WindowButtonDownFcn'  ,'nuevent(0,0,8)',...
                      'KeyPressFcn'          ,'nuevent(0,0,9)',...
                      'Position',user.view);
    prg.axes=subplot('Position',[0.05 0.05 0.9 0.9]);
    prg.run=0; % wait until first data arrives
  else
    nu.run=0;
  end
else
  switch varargin{1}
    case 'loop'
      if ~prg.run
        if nu.numel
          if length(nu.varargin)==1
            prg.cast=find(all(nu.cell{end}<1));
          else
            prg.cast=nu.varargin{2};
          end
          prg.cast=[1:10];
          prg.length=6;                             % interval length [sec] for x axis range          
          prg.plot=zeros(1,length(prg.cast));       % preallocate space for plot handles    
          prg.mesh=zeros(1,length(prg.cast));       % preallocate space for plot handles    
          prg.numel=max(3,nu.numel);                % 0<nu.numel guaranteed by nu_main ! => that means ...
          prg.xdata=[];
          prg.ydata=[];
          prg.zdata=[];
          for c1=1:length(prg.cast)
            prg.plot(c1)=plot(0,0,'Color',nuget('color',c1));
            hold on
          end
          for c1=1:length(prg.cast)
            prg.mesh(c1)=plot(0,0,'Color',nuget('color',c1),'LineStyle',':');            
          end
          prg.toc=toc;
          xlabel('[sec]')
          axis([prg.toc-prg.length prg.toc 0 length(prg.cast)+1])
          set(prg.axes,'YTick',1:length(prg.cast))
          set(prg.axes,'YTickLabel',nu.text(prg.cast))
          prg.legend=legend(nu.text(prg.cast),'Location','NorthWest');
        end
        prg.run=nu.numel;
      else
        prg.toc=toc;
        if nu.pause<0.2 & ~mod(numel(nu.trace.print),2)
          val=1;
          if prg.numel<nu.numel
            val=2;
            num=nu.numel; % for thread safety store nu.numel into local variable
            % get data from eeg that has not been plotted before
            ydata=cell2mat(nu.cell(prg.numel+1:num)); % 200 * nu.numel  x   40   TODO check            
            zdata=ydata;
            mat=[ydata ones(size(ydata,1),1)];
            est=mat(:,user.eye.corrcoef{end}(:,1)) * user.eye.corrcoef{end}(:,2:3);            
            chn=user.eye.classdef{end}(:,1);
            cof=user.eye.classdef{end}(:,2:3);
            for c1=1:numel(chn)
              ydata(:,chn(c1))=ydata(:,chn(c1))-est*cof(c1,:)';
            end
            %switch 1
            %case 1
            ydata=fft(ydata);
            cut=9*size(ydata,1)/200;
            ydata(1+cut:end-cut+1,chn)=0;
            ydata=ifft(ydata);              
            zdata=fft(zdata);
            cut=9*size(zdata,1)/200;
            zdata(1+cut:end-cut+1,chn)=0;
            zdata=ifft(zdata);
            %case 2
            %  blk=size(ydata,1)/2;
            %  ydata=fft([ydata;ydata]);
            %  cut=8*size(ydata,1)/200;
            %  ydata(1+cut:end-cut+1,chn)=0;
            %  ydata=ifft(ydata);
            %  ydata=[ ydata(blk*2+1:blk*3,:) ; ydata(blk+1:blk*2,:) ];
            %end            
            prg.xdata=[prg.xdata prg.numel*0.2+[1:size(ydata,1)]*1e-3];  % sample to time [sec] conversion      
            prg.ydata=[prg.ydata;ydata];
            prg.zdata=[prg.zdata;zdata];
            prg.numel=num; % update the data range that has been plotted
            %xdata=get(prg.plot(1),'XData');
            fnd=find( prg.toc-prg.length <= prg.xdata);
            prg.xdata=prg.xdata(fnd); % values in x-range that are in viewport
            prg.ydata=prg.ydata(fnd,:);
            prg.zdata=prg.zdata(fnd,:);
            prg.min= 1000;
            prg.max=-1000;
            col=cell(length(prg.cast),1);
            for c1=1:length(prg.cast)
              set(prg.plot(c1),'XData',prg.xdata)
              set(prg.mesh(c1),'XData',prg.xdata)
              ydata=prg.ydata(:,prg.cast(c1))';
              zdata=prg.zdata(:,prg.cast(c1))';
              alo=min(min(ydata),min(zdata));
              amp=max(max(ydata),max(zdata))-alo;
              ydata=ydata-(alo+amp*0.5);
              ydata=ydata*(1/amp)+c1;
              set(prg.plot(c1),'YData',ydata);
              zdata=zdata-(alo+amp*0.5);
              zdata=zdata*(1/amp)+c1;
              set(prg.mesh(c1),'YData',zdata);
              col{c1}=sprintf('%s %f mV',nu.text{prg.cast(c1)},amp*1e3);
            end
            set(prg.legend,'String',col)
          end
          axis(prg.axes,[prg.toc-prg.length prg.toc 0.5 length(prg.cast)+0.5]) % update the viewport
        else          
          val=0; % software is lagging
        end
      end
    case 'stop'
      close(prg.figure)
    otherwise
      warning('unknown command')
  end
end
