function val=prg_randomcurve(varargin)
% code by jph

global nu user
persistent prg

val=[];

if isempty(findobj('type','figure','name',mfilename)) 
  if ~nargin
    sec=120; % total duration
    nurun(0+[0:0.04:sec], 'prg_flashcurve(''loop'')')
    nurun(sec           , 'prg_flashcurve(''stop'')')
    
    nu.light.shading=1020;
    nu.light.legend={'event'};
    prg_light    
    prg.figure=figure('Name',mfilename,...
                      'Numbertitle','off',...
                      'Menubar','none',...                         % 'Pointer','custom',...                      %'PointerShapeCData',zeros(16)*NaN,...
                      'DoubleBuffer','on',...
                      'WindowButtonMotionFcn','nuevent(0,0,7)',... % simulink
                      'Color',[0 0 0],...
                      'Position',user.view);
    prg.axes=subplot('Position',[0 0 1 1]);
    prg.sound={
      wavread('res/eeg_knock1.wav')
      wavread('res/eeg_knock2.wav')
      wavread('res/eeg_knock3.wav')
    };
    prg.sound
    prg.scatter=zeros(1,numel(nu.events)); % way too many
    jmp=8;
    for c1=1:jmp:numel(prg.scatter)-jmp;
      prg.scatter(c1+floor(rand*(jmp-1)))=ceil(rand*numel(prg.sound));
    end
    fmt=[21 13]; % [1680 1050]
    [x,y]=meshgrid(0:fmt(1),0:fmt(2));
    f=find(x==0|y==0|x==fmt(1)|y==fmt(2));
    PNT=[x(f) y(f)]';
    num=size(PNT,2);
    prg.pnt=PNT(:,randperm(num));
    prg.pnt(:,[1 2 floor(end/2) floor(end/2)+1 end-1 end])=repmat([fmt(1)*0.5+0.1;fmt(2)*0.5],[1 6]);
    prg.length=sec;
    prg.dom=linspace(0,prg.length,num);
    crX=interp1(prg.dom,prg.pnt(1,:),linspace(0,prg.length,prg.length*10),'cubic');
    crY=interp1(prg.dom,prg.pnt(2,:),linspace(0,prg.length,prg.length*10),'cubic');
    plot(crX,crY,':','Color',[0.2 0.2 0]);
    hold on
    %plot(prg.pnt(1,:),prg.pnt(2,:),'*','Color',[0.3 0 0]);
    mrg=0.3;
    axis([ 0-mrg fmt(1)+mrg 0-mrg fmt(2)+mrg ])
    axis off
    prg.snp=plot(crX(1),crY(1));
    prg.mrk=plot(crX(1),crY(1),'.g','MarkerSize',24);
    
    prg.rectangle.hnd=rectangle('Position',[-mrg -mrg mrg*1.5 mrg*1.5],'FaceColor','k','EraseMode','background','Visible','on');
    prg.rectangle.cnt=0;
    prg.text=text(0,fmt(2)+mrg/2,'test','Color',[.2 .2 .2],'FontSize',8);
  else
    % optional to terminate when figure is closed manually
    % works because global nu
    nu.run=0;
  end
else
  switch varargin{1}
  case 'loop'
    set(prg.text,'String',num2str(nu.pause))
    if nu.pause<0.2 % mechanism to prevent outage
      tim=nu.toc;
      dom=linspace(-0.2,0.2,10)+tim;
      px=interp1(prg.dom,prg.pnt(1,:),tim,'cubic');
      py=interp1(prg.dom,prg.pnt(2,:),tim,'cubic');
      set(prg.mrk,'XData',px);
      set(prg.mrk,'YData',py);
      set(prg.snp,'XData',interp1(prg.dom,prg.pnt(1,:),dom,'cubic'));
      set(prg.snp,'YData',interp1(prg.dom,prg.pnt(2,:),dom,'cubic'));
      prg.rectangle.cnt=prg.rectangle.cnt+1;
      ron=1+(mod(prg.rectangle.cnt,15)<2);      
      set(prg.rectangle.hnd,'FaceColor',repmat(ron-1,[1 3]))
      act=prg.scatter(ceil(prg.rectangle.cnt/15));
      if act & ~mod(prg.rectangle.cnt,15)
        set(prg.mrk,'MarkerSize',170)
        set(prg.mrk,'Color','r')
        nu.light.events=vertcat(nu.light.events,[nu.case 1]);
        sound(prg.sound{act},44100,16)
      else
        set(prg.mrk,'MarkerSize',24)
        set(prg.mrk,'Color','g')
      end
      val=[tim px py ron];
    else
      val=0;
    end
  case 'stop'
    close(prg.figure)
  end
end
